﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>
<%@ Register assembly="C1.Web.Wijmo.Controls.4" namespace="C1.Web.Wijmo.Controls.C1GridView" tagprefix="wijmo" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
	<title></title>
</head>
<body>
<script type="text/javascript">
	function onBeforeCellEdit(e, args) {
		if (args.cell.column().dataField == "SupplierID") {
			args.handled = true;

            //get the container of the current cell
			var container = args.cell.container(),
				cellValue = $.trim(container.text()),
				select = $("#<%= suppliersDDL.ClientID %>");
            //unhide the customer editor
			select.val(cellValue).css("visibility", "visible");
            //append the editor to current cell
			container.empty().append(select);
		}
	}

	function onBeforeCellUpdate(e, args) {
		if (args.cell.column().dataField == "SupplierID") {
			args.value = $("#<%= suppliersDDL.ClientID %>").val();

            //check if blank value is entered by end user
			if (!args.value && (args.value !== 0)) {
				window.alert("Empty values are not allowed.");
				args.cell.container().find("input").focus();
				return false;
			}
		}
	}

	function onAfterCellEdit(e, args) {
		if (args.cell.column().dataField == "SupplierID") {
			args.handled = true;
			var select = $("#<%= suppliersDDL.ClientID %>");
            //hide the customer editor
			select.css("visibility", "hidden");
			$("#ddlParent").append(select);

			args.cell.container().text(args.cell.value() + "");
		}
	}

</script>
	<form id="form1" runat="server">

	<asp:ScriptManager runat="server" ID="sm1"></asp:ScriptManager>

	<asp:UpdatePanel ID="UpdatePanel1" runat="server" UpdateMode="Conditional">
		<ContentTemplate>
			<wijmo:C1GridView ID="C1GridView1" runat="server" DataKeyNames="ProductID" 
				CallbackSettings-Action="Editing"
				OnClientAfterCellEdit="onAfterCellEdit"
				OnClientBeforeCellEdit="onBeforeCellEdit"
				OnClientBeforeCellUpdate="onBeforeCellUpdate" 
				AllowClientEditing="true"                
				AutoGenerateColumns="false" ShowRowHeader="true">
				<Columns>
					 <wijmo:C1BoundField DataField="ProductID" HeaderText="ProductID" ReadOnly="true" />
					 <wijmo:C1BoundField DataField="ProductName" HeaderText="ProductName" />
					 <wijmo:C1BoundField DataField="SupplierID" HeaderText="SupplierID" />
					 <wijmo:C1CheckBoxField  DataField="Discontinued" HeaderText="Discontinued" />
				</Columns>
			</wijmo:C1GridView>

			<div id="ddlParent">
				<asp:DropDownList runat="server" ID="suppliersDDL" DataTextField="CompanyName" DataValueField="SupplierID" style="visibility:hidden; width:auto" />
			</div>
		</ContentTemplate>
	</asp:UpdatePanel>

	</form>

</body>
</html>
