﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

using C1.Web.Wijmo.Controls.C1GridView;

public partial class _Default : System.Web.UI.Page
{
	protected void Page_Init(object sender, EventArgs e)
	{
		C1GridView1.RowUpdating += new C1.Web.Wijmo.Controls.C1GridView.C1GridViewUpdateEventHandler(C1GridView1_RowUpdating);
		C1GridView1.EndRowUpdated += new C1.Web.Wijmo.Controls.C1GridView.C1GridViewEndRowUpdatedEventHandler(C1GridView1_EndRowUpdated);
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		if (!IsPostBack)
		{
			suppliersDDL.DataSource = GetSuppliers();
			suppliersDDL.DataBind();

			C1GridView1.DataSource = GetProducts();
			C1GridView1.DataBind();
		}
	}

	void C1GridView1_RowUpdating(object sender, C1.Web.Wijmo.Controls.C1GridView.C1GridViewUpdateEventArgs e)
	{
		List<ProductInfo> products = GetProducts();

		ProductInfo product = products.Find(delegate(ProductInfo info)
		{
			return info.ProductID.Equals(e.Keys["ProductID"]);
		});

		if (product != null)
		{
			if (e.NewValues.Contains("ProductName"))
			{
				product.ProductName = (string)e.NewValues["ProductName"];
			}

			if (e.NewValues.Contains("SupplierID"))
			{
				product.SupplierID = (int)e.NewValues["SupplierID"];
			}

			if (e.NewValues.Contains("Discontinued"))
			{
				product.Discontinued = (bool)e.NewValues["Discontinued"];
			}
		}
	}

	void C1GridView1_EndRowUpdated(object sender, C1.Web.Wijmo.Controls.C1GridView.C1GridViewEndRowUpdatedEventArgs e)
	{
		C1GridView1.DataSource = GetProducts();
		C1GridView1.DataBind();
	}


	private List<ProductInfo> GetProducts()
	{
		if (Session["Products"] == null)
		{
			List<ProductInfo> _products = new List<ProductInfo>();

			_products.Add(new ProductInfo(1, "Chai", 1, true));
			_products.Add(new ProductInfo(2, "Chang", 2, false));
			_products.Add(new ProductInfo(3, "Aniseed Syrup", 3, false));
			_products.Add(new ProductInfo(4, "Chef Anton's Cajun Seasoning", 4, false));
			_products.Add(new ProductInfo(5, "Chef Anton's Gumbo Mix", 5, true));
			_products.Add(new ProductInfo(6, "Grandma's Boysenberry Spread", 6, true));
			_products.Add(new ProductInfo(7, "Uncle Bob's Organic Dried Pears", 7, false));
			_products.Add(new ProductInfo(8, "Northwoods Cranberry Sauce", 8, false));
			_products.Add(new ProductInfo(9, "Mishi Kobe Niku", 9, false));
			_products.Add(new ProductInfo(10, "Ikura", 10, true));

			Session["Products"] = _products;
		}

		return (List<ProductInfo>)Session["Products"];
	}

	private List<SupplierInfo> GetSuppliers()
	{
		if (Session["Suppliers"] == null)
		{
			List<SupplierInfo> _suppliers = new List<SupplierInfo>();

			_suppliers.Add(new SupplierInfo(1, "Exotic Liquids"));
			_suppliers.Add(new SupplierInfo(2, "New Orleans Cajun Delights"));
			_suppliers.Add(new SupplierInfo(3, "Grandma Kelly's Homestead"));
			_suppliers.Add(new SupplierInfo(4, "Tokyo Traders"));
			_suppliers.Add(new SupplierInfo(5, "Cooperativa de Quesos 'Las Cabras'"));
			_suppliers.Add(new SupplierInfo(6, "Mayumi's"));
			_suppliers.Add(new SupplierInfo(7, "Pavlova, Ltd."));
			_suppliers.Add(new SupplierInfo(8, "Specialty Biscuits, Ltd."));
			_suppliers.Add(new SupplierInfo(9, "PB Knäckebröd AB"));
			_suppliers.Add(new SupplierInfo(10, "Refrescos Americanas LTDA"));

			Session["Suppliers"] = _suppliers;
		}

		return (List<SupplierInfo>)Session["Suppliers"];
	}

	private class SupplierInfo
	{
		private int _supplierID;
		private string _companyName;

		public SupplierInfo(int supplierID, string companyName)
		{
			_supplierID = supplierID;
			_companyName = companyName;
		}

		public int SupplierID
		{
			get { return _supplierID; }
			set { _supplierID = value; }
		}

		public string CompanyName
		{
			get { return _companyName; }
			set { _companyName = value; }
		}
	}

	private class ProductInfo
	{
		private int _productID;
		private string _productName;
		private int _supplierID;
		private bool _discontinued;

		public ProductInfo(int productID, string productName, int supplierID, bool discontinued)
		{
			_productID = productID;
			_productName = productName;
			_supplierID = supplierID;
			_discontinued = discontinued;
		}

		public int ProductID
		{
			get { return _productID; }
			set { _productID = value; }
		}

		public string ProductName
		{
			get { return _productName; }
			set { _productName = value; }
		}

		public int SupplierID
		{
			get { return _supplierID; }
			set { _supplierID = value; }
		}

		public bool Discontinued
		{
			get { return _discontinued; }
			set { _discontinued = value; }
		}
	}

}